//+------------------------------------------------------------------+
//|                                                 II_CrashZone.mq4 |
//|                            Copyright  2010, Insanity Industries |
//|                                http://www.insanityindustries.net |
//| v.1.3 3/6/2010                                                  |
//| code by bredin, except where noted                               |
//| idea by mightyone                                                |
//| donations can be made via PayPal to bredin@lpemail.com           |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Insanity Industries"
#property link      "http://www.insanityindustries.net"

#property indicator_chart_window
extern int object_layer = 8;
extern bool weekly_extreme_on = false;
extern bool target_long = true;
extern bool target_short = true;
extern bool fill_target_zones = true;
extern string target_text = "Cash Zone";
extern int line_style = 0;
extern int line_width = 0;
extern int extreme_line_style = 0;
extern int extreme_line_width = 0;
extern color color_cz_long = 0x008000;
extern color color_cz_short = 0x000080;
extern color color_extreme_low = Green;
extern color color_extreme_high = Crimson;
extern color color_zone_long = 0x002000;
extern color color_zone_short = 0x000020;


double cz_level_array[4]={0.667,0.833,1.167,1.333};
string cz_level_desc_long[4];//={"W1 Low : ","Target 1 : ","","Target 2 : ",""};
string cz_level_desc_short[4];//={"W1 High : ","Target 1 : ","","Target 2 : ",""};
string TAG = "";
string LAYER;
double cz_long[4];
double cz_short[4];

double LOW,HIGH,TIME;

int init()
{
   if (object_layer > 26) object_layer = 26;
   LAYER = CharToStr(0x61+object_layer);
   TAG = LAYER + "II_CrashZone";
   setArray();
   DoLogo();
   return(0);
}


int deinit(){
   ObDeleteObjectsByPrefix(TAG); 
   return(0);
}

int start(){
   if(!(Bid > HIGH || Bid < LOW)) return(0);
  
   double range[3];
   string s,d;
   int i,j;
   for(i=1;i<4;i++) range[i-1] = iHigh(NULL,PERIOD_W1,i) - iLow(NULL,PERIOD_W1,i);
   ArraySort(range);
   int level_count = ArraySize(cz_level_array);
   
   TIME = iTime(NULL,PERIOD_W1,0);
   
   if(target_long){
      LOW = iLow(NULL,PERIOD_W1,0);
      s = TAG+"CZ.Long";
      drawFibo(s,TIME,LOW+range[1],TIME,LOW,line_style,line_width,level_count,color_cz_long);
      for(j=0; j<level_count; j++){
         ObjectSet(s, OBJPROP_FIRSTLEVEL+j, cz_level_array[j]);
         cz_long[j] = NormalizeDouble(LOW+range[1]*cz_level_array[j],Digits);
         d = cz_level_desc_long[j]+DoubleToStr(LOW+(range[1]*cz_level_array[j]),Digits)+"      ";
         ObjectSetFiboDescription(s,j,d);
      }
      
      if(fill_target_zones){
         s = TAG+"CZ.LF1";
         ObjectCreate(s,OBJ_RECTANGLE,0,0,0,0,0);
         ObjectSet(s, OBJPROP_TIME1, TIME);
         ObjectSet(s, OBJPROP_PRICE1, cz_long[0]);
         ObjectSet(s, OBJPROP_TIME2, D'01.01.2019');
         ObjectSet(s, OBJPROP_PRICE2, cz_long[1]);
         ObjectSet(s,OBJPROP_COLOR, color_zone_long);
         ObjectSet(s,OBJPROP_BACK, true);
         s = TAG+"CZ.LF2";
         ObjectCreate(s,OBJ_RECTANGLE,0,0,0,0,0);
         ObjectSet(s, OBJPROP_TIME1, TIME);
         ObjectSet(s, OBJPROP_PRICE1, cz_long[2]);
         ObjectSet(s, OBJPROP_TIME2, D'01.01.2019');
         ObjectSet(s, OBJPROP_PRICE2, cz_long[3]);
         ObjectSet(s,OBJPROP_COLOR, color_zone_long);
         ObjectSet(s,OBJPROP_BACK, true);
      }
      
      if(weekly_extreme_on){
         s = TAG+"CZ.Low";
         drawFibo(s,TIME,LOW,TIME,LOW,extreme_line_style,extreme_line_width,1,color_extreme_low);
         d = "W1 Low : "+DoubleToStr(LOW,Digits)+" ";
         ObjectSetFiboDescription(s,0,d);
      }
   }
   
   if(target_short){
      HIGH = iHigh(NULL,PERIOD_W1,0);
      s = TAG+"CZ.Short";
      drawFibo(s,TIME,HIGH-range[1],TIME,HIGH,line_style,line_width,level_count,color_cz_short);
      for(j=0; j<level_count; j++){
         ObjectSet(s, OBJPROP_FIRSTLEVEL+j, cz_level_array[j]);
         cz_short[j] = NormalizeDouble(HIGH-range[1]*cz_level_array[j],Digits);
         d = cz_level_desc_short[j]+DoubleToStr(HIGH-(range[1]*cz_level_array[j]),Digits)+"      ";
         ObjectSetFiboDescription(s,j,d);
      }
      
         if(fill_target_zones){
         s = TAG+"CZ.SF1";
         ObjectCreate(s,OBJ_RECTANGLE,0,0,0,0,0);
         ObjectSet(s, OBJPROP_TIME1, TIME);
         ObjectSet(s, OBJPROP_PRICE1, cz_short[0]);
         ObjectSet(s, OBJPROP_TIME2, D'01.01.2019');
         ObjectSet(s, OBJPROP_PRICE2, cz_short[1]);
         ObjectSet(s,OBJPROP_COLOR, color_zone_short);
         ObjectSet(s,OBJPROP_BACK, true);
         s = TAG+"CZ.SF2";
         ObjectCreate(s,OBJ_RECTANGLE,0,0,0,0,0);
         ObjectSet(s, OBJPROP_TIME1, TIME);
         ObjectSet(s, OBJPROP_PRICE1, cz_short[2]);
         ObjectSet(s, OBJPROP_TIME2, D'01.01.2019');
         ObjectSet(s, OBJPROP_PRICE2, cz_short[3]);
         ObjectSet(s,OBJPROP_COLOR, color_zone_short);
         ObjectSet(s,OBJPROP_BACK, true);
      }
      
      if(weekly_extreme_on){
         s = TAG+"CZ.High";
         drawFibo(s,TIME,HIGH,TIME,HIGH,extreme_line_style,extreme_line_width,1,color_extreme_high);
         d = "W1 High : "+DoubleToStr(HIGH,Digits)+" ";
         ObjectSetFiboDescription(s,0,d);
      }
   }
//   Comment("LOW : ",ObjectGet(LAYER+TAG+"CZ.Long",OBJPROP_FIRSTLEVEL),"\nHIGH : ",HIGH);
   return(0);
}

void drawFibo(string n, datetime t1, double p1, datetime t2, double p2, int st, int w, int l, color lc, color c = CLR_NONE)
{
   ObjectDelete(n);
   ObjectCreate(n, OBJ_FIBO, 0,t1,p1,t2,p2);
   ObjectSet(n, OBJPROP_COLOR, c);
   ObjectSet(n, OBJPROP_STYLE, st);
   ObjectSet(n, OBJPROP_WIDTH, w);
   ObjectSet(n, OBJPROP_RAY, true);
   ObjectSet(n, OBJPROP_BACK, true);   
   ObjectSet(n, OBJPROP_FIBOLEVELS, l);
   ObjectSet(n, OBJPROP_LEVELCOLOR, lc);
}

void setArray()
{
   cz_level_desc_long[0]= target_text+" 1 : ";
   cz_level_desc_long[1]= "";
   cz_level_desc_long[2]= target_text+" 2 : ";
   cz_level_desc_long[3]= "";
   cz_level_desc_short[0]= target_text+" 1 : ";
   cz_level_desc_short[1]= "";
   cz_level_desc_short[2]= target_text+" 2 : ";
   cz_level_desc_short[3]= "";
}

void ObDeleteObjectsByPrefix(string Prefix){ //code by TRO
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal()) {
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix) {
         i++;
         continue;
      }
      ObjectDelete(ObjName);
   }
}

void DoLogo(){
   string tTAG = CharToStr(0x61+27)+"II_Logo";
   if( ObjectFind(tTAG+"ZZ"+0) >= 0 && ObjectFind(TAG+"ZZ"+1) >= 0 && ObjectFind(tTAG+"ZZ"+2) >= 0  && 
       ObjectFind(tTAG+"AZ"+0) >= 0 && ObjectFind(TAG+"AZ"+1) >= 0 && ObjectFind(tTAG+"AZ"+2) >= 0 ) return;
   string str[3] = {"$","Insanity","Industries"};
   int size[3] = {25,10,10};
   int pos_x[3] = {47,19,17};
   int pos_y[3] = {10,25,15};
   int pos_xs[3] = {46,18,16};
   int pos_ys[3] = {9,24,14};
   for(int i=0;i<3;i++){
      string n = tTAG+"ZZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",AliceBlue);
      ObjectSet(n,OBJPROP_XDISTANCE,pos_x[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos_y[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
      n = tTAG+"AZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",Black);
      ObjectSet(n,OBJPROP_XDISTANCE,pos_xs[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos_ys[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
   }
}